
_Reset_PID:
	LNK	#0

;PID_Lib.mpas,59 :: 		begin
;PID_Lib.mpas,62 :: 		PID_Integrated := 0.0;
	MOV	[W14-8], W0
	ADD	W0, #12, W2
	CLR	W0
	CLR	W1
	MOV.D	W0, [W2]
;PID_Lib.mpas,63 :: 		PID_Prev_Input := 0.0;
	MOV	[W14-8], W0
	ADD	W0, #16, W2
	CLR	W0
	CLR	W1
	MOV.D	W0, [W2]
;PID_Lib.mpas,64 :: 		PID_First_Time := true;
	MOV	[W14-8], W0
	ADD	W0, #28, W1
	MOV	#65535, W0
	MOV	W0, [W1]
;PID_Lib.mpas,66 :: 		end;
L_end_Reset_PID:
	ULNK
	RETURN
; end of _Reset_PID

_Set_PID_Int_Improvement:
	LNK	#0

;PID_Lib.mpas,69 :: 		begin
;PID_Lib.mpas,70 :: 		Controller.PID_Int_Improvement := On_;
	MOV	[W14-8], W0
	ADD	W0, #30, W1
	MOV	[W14-10], W0
	MOV	W0, [W1]
;PID_Lib.mpas,71 :: 		end;
L_end_Set_PID_Int_Improvement:
	ULNK
	RETURN
; end of _Set_PID_Int_Improvement

_Init_PID:
	LNK	#0

;PID_Lib.mpas,74 :: 		begin
;PID_Lib.mpas,77 :: 		PID_Kp              := Kp;
	MOV	[W14-8], W2
	MOV	[W14-12], W0
	MOV	[W14-10], W1
	MOV.D	W0, [W2]
;PID_Lib.mpas,78 :: 		PID_Ki              := Ki;
	MOV	[W14-8], W0
	ADD	W0, #4, W2
	MOV	[W14-16], W0
	MOV	[W14-14], W1
	MOV.D	W0, [W2]
;PID_Lib.mpas,79 :: 		PID_Kd              := Kd;
	MOV	[W14-8], W0
	ADD	W0, #8, W2
	MOV	[W14-20], W0
	MOV	[W14-18], W1
	MOV.D	W0, [W2]
;PID_Lib.mpas,80 :: 		PID_MinOutput       := MinOutput;
	MOV	[W14-8], W0
	ADD	W0, #20, W2
	MOV	[W14-24], W0
	MOV	[W14-22], W1
	MOV.D	W0, [W2]
;PID_Lib.mpas,81 :: 		PID_MaxOutput       := MaxOutput;
	MOV	[W14-8], W0
	ADD	W0, #24, W2
	MOV	[W14-28], W0
	MOV	[W14-26], W1
	MOV.D	W0, [W2]
;PID_Lib.mpas,82 :: 		PID_Integrated      := 0.0;
	MOV	[W14-8], W0
	ADD	W0, #12, W2
	CLR	W0
	CLR	W1
	MOV.D	W0, [W2]
;PID_Lib.mpas,83 :: 		PID_Prev_Input      := 0.0;
	MOV	[W14-8], W0
	ADD	W0, #16, W2
	CLR	W0
	CLR	W1
	MOV.D	W0, [W2]
;PID_Lib.mpas,84 :: 		PID_Int_Improvement := false;
	MOV	[W14-8], W0
	ADD	W0, #30, W1
	CLR	W0
	MOV	W0, [W1]
;PID_Lib.mpas,85 :: 		PID_First_Time      := true;
	MOV	[W14-8], W0
	ADD	W0, #28, W1
	MOV	#65535, W0
	MOV	W0, [W1]
;PID_Lib.mpas,87 :: 		end;
L_end_Init_PID:
	ULNK
	RETURN
; end of _Init_PID

PID_Lib_Sign:
	LNK	#2

;PID_Lib.mpas,90 :: 		begin
;PID_Lib.mpas,91 :: 		Result := 0;                     // negative
	CLR	W0
	MOV.B	W0, [W14+0]
;PID_Lib.mpas,92 :: 		if Value >= 0 then Result := 1;  // positive
	CLR	W2
	CLR	W3
	MOV	[W14-10], W0
	MOV	[W14-8], W1
	CALL	__Compare_Ge_Fp
	CP0	W0
	CLR	W0
	BRA LT	L_PID_Lib_Sign28
	COM	W0
L_PID_Lib_Sign28:
	CP0	W0
	BRA NZ	L_PID_Lib_Sign29
	GOTO	L_PID_Lib_Sign5
L_PID_Lib_Sign29:
	MOV.B	#1, W0
	MOV.B	W0, [W14+0]
L_PID_Lib_Sign5:
;PID_Lib.mpas,93 :: 		end;
	MOV.B	[W14+0], W0
L_end_Sign:
	ULNK
	RETURN
; end of PID_Lib_Sign

PID_Lib_Limit:
	LNK	#0

;PID_Lib.mpas,96 :: 		begin
;PID_Lib.mpas,97 :: 		if Value < MinOutput
	MOV	[W14-8], W2
	MOV.D	[W2], W0
	MOV	[W14-12], W2
	MOV	[W14-10], W3
	CALL	__Compare_Le_Fp
	CP0	W0
	CLR	W0
	BRA GE	L_PID_Lib_Limit31
	COM	W0
L_PID_Lib_Limit31:
	CP0	W0
	BRA NZ	L_PID_Lib_Limit32
	GOTO	L_PID_Lib_Limit9
L_PID_Lib_Limit32:
;PID_Lib.mpas,98 :: 		then Value := MinOutput
	MOV	[W14-8], W2
	MOV	[W14-12], W0
	MOV	[W14-10], W1
	MOV.D	W0, [W2]
	GOTO	L_PID_Lib_Limit10
;PID_Lib.mpas,99 :: 		else if Value > MaxOutput then Value := MaxOutput;
L_PID_Lib_Limit9:
	MOV	[W14-8], W2
	MOV.D	[W2], W0
	MOV	[W14-16], W2
	MOV	[W14-14], W3
	CALL	__Compare_Ge_Fp
	CP0	W0
	CLR	W0
	BRA LE	L_PID_Lib_Limit33
	COM	W0
L_PID_Lib_Limit33:
	CP0	W0
	BRA NZ	L_PID_Lib_Limit34
	GOTO	L_PID_Lib_Limit12
L_PID_Lib_Limit34:
	MOV	[W14-8], W2
	MOV	[W14-16], W0
	MOV	[W14-14], W1
	MOV.D	W0, [W2]
L_PID_Lib_Limit12:
L_PID_Lib_Limit10:
;PID_Lib.mpas,100 :: 		end;
L_end_Limit:
	ULNK
	RETURN
; end of PID_Lib_Limit

_PID_Calculate:
	LNK	#20

;PID_Lib.mpas,104 :: 		begin
;PID_Lib.mpas,108 :: 		Err := SetPoint - InputValue;
	MOV	[W14-12], W0
	MOV	[W14-10], W1
	MOV	[W14-16], W2
	MOV	[W14-14], W3
	CALL	__Sub_FP
	MOV	W0, [W14+4]
	MOV	W1, [W14+6]
;PID_Lib.mpas,111 :: 		ErrValue  := Err * PID_Kp;
	MOV	[W14-8], W4
	MOV.D	[W4], W2
	CALL	__Mul_FP
	MOV	W0, [W14+8]
	MOV	W1, [W14+10]
;PID_Lib.mpas,114 :: 		if PID_Int_Improvement then if Sign(Err) <> Sign(PID_Integrated) then PID_Integrated := 0;
	MOV	[W14-8], W0
	ADD	W0, #30, W0
	CP0	[W0]
	BRA NZ	L__PID_Calculate36
	GOTO	L__PID_Calculate16
L__PID_Calculate36:
	ADD	W14, #4, W0
	PUSH	[W0++]
	PUSH	[W0--]
	CALL	PID_Lib_Sign
	SUB	#4, W15
	MOV.B	W0, [W14+16]
	MOV	[W14-8], W0
	ADD	W0, #12, W0
	PUSH	[W0++]
	PUSH	[W0--]
	CALL	PID_Lib_Sign
	SUB	#4, W15
	MOV.B	[W14+16], W1
	CP.B	W1, W0
	BRA NZ	L__PID_Calculate37
	GOTO	L__PID_Calculate19
L__PID_Calculate37:
	MOV	[W14-8], W0
	ADD	W0, #12, W2
	CLR	W0
	CLR	W1
	MOV.D	W0, [W2]
L__PID_Calculate19:
L__PID_Calculate16:
;PID_Lib.mpas,117 :: 		PID_Integrated := PID_Integrated + (Err * PID_Ki);
	MOV	[W14-8], W0
	ADD	W0, #12, W0
	MOV	W0, [W14+18]
	MOV	[W14-8], W0
	ADD	W0, #12, W0
	MOV	W0, [W14+16]
	MOV	[W14-8], W0
	ADD	W0, #4, W2
	MOV.D	[W2], W0
	MOV	[W14+4], W2
	MOV	[W14+6], W3
	CALL	__Mul_FP
	MOV	[W14+16], W4
	MOV.D	[W4], W2
	CALL	__AddSub_FP
	MOV	[W14+18], W2
	MOV.D	W0, [W2]
;PID_Lib.mpas,119 :: 		Limit(PID_Integrated, PID_MinOutput, PID_MaxOutput);
	MOV	[W14-8], W0
	ADD	W0, #12, W2
	MOV	[W14-8], W0
	ADD	W0, #20, W1
	MOV	[W14-8], W0
	ADD	W0, #24, W0
	PUSH	[W0++]
	PUSH	[W0--]
	PUSH	[W1++]
	PUSH	[W1--]
	PUSH	W2
	CALL	PID_Lib_Limit
	SUB	#10, W15
;PID_Lib.mpas,122 :: 		if PID_First_Time then
	MOV	[W14-8], W0
	ADD	W0, #28, W0
	CP0	[W0]
	BRA NZ	L__PID_Calculate38
	GOTO	L__PID_Calculate22
L__PID_Calculate38:
;PID_Lib.mpas,124 :: 		PID_First_Time := false;
	MOV	[W14-8], W0
	ADD	W0, #28, W1
	CLR	W0
	MOV	W0, [W1]
;PID_Lib.mpas,125 :: 		PID_Prev_Input := InputValue;
	MOV	[W14-8], W0
	ADD	W0, #16, W2
	MOV	[W14-16], W0
	MOV	[W14-14], W1
	MOV.D	W0, [W2]
;PID_Lib.mpas,126 :: 		end;
L__PID_Calculate22:
;PID_Lib.mpas,127 :: 		DiffValue := (InputValue - PID_Prev_Input) * PID_Kd;
	MOV	[W14-8], W0
	ADD	W0, #16, W0
	MOV.D	[W0], W2
	MOV	[W14-16], W0
	MOV	[W14-14], W1
	CALL	__Sub_FP
	MOV	[W14-8], W2
	ADD	W2, #8, W4
	MOV.D	[W4], W2
	CALL	__Mul_FP
	MOV	W0, [W14+12]
	MOV	W1, [W14+14]
;PID_Lib.mpas,128 :: 		PID_Prev_Input := InputValue;
	MOV	[W14-8], W0
	ADD	W0, #16, W2
	MOV	[W14-16], W0
	MOV	[W14-14], W1
	MOV.D	W0, [W2]
;PID_Lib.mpas,131 :: 		Result := ErrValue + PID_Integrated - DiffValue; // mind the minus sign!!!
	MOV	[W14-8], W0
	ADD	W0, #12, W0
	MOV.D	[W0], W2
	MOV	[W14+8], W0
	MOV	[W14+10], W1
	CALL	__AddSub_FP
	MOV	[W14+12], W2
	MOV	[W14+14], W3
	CALL	__Sub_FP
	MOV	W0, [W14+0]
	MOV	W1, [W14+2]
;PID_Lib.mpas,133 :: 		Limit(Result, PID_MinOutput, PID_MaxOutput);
	MOV	[W14-8], W0
	ADD	W0, #20, W1
	MOV	[W14-8], W0
	ADD	W0, #24, W0
	PUSH	[W0++]
	PUSH	[W0--]
	PUSH	[W1++]
	PUSH	[W1--]
	ADD	W14, #0, W0
	PUSH	W0
	CALL	PID_Lib_Limit
	SUB	#10, W15
;PID_Lib.mpas,136 :: 		end;
	MOV	[W14+0], W0
	MOV	[W14+2], W1
L_end_PID_Calculate:
	ULNK
	RETURN
; end of _PID_Calculate
